#!/usr/bin/perl -w

use strict;

use cosmic;

sub ShowUnaryLesson {
  my $txt = "";

  $txt .= "# MATH introduce numbers (in unary notation)\n";
  for (my $i=0; $i<=27; $i++)
    {
      $txt .= ShowLine(Op("intro",ShowUnary($i)));
    }
  
  for (my $i=27; $i>=0; $i--)
    {
      $txt .= ShowLine(Op("intro",ShowUnary($i)));
    }

  foreach my $i (0, 1, 2, 3, 5, 7, 11, 13, 17, 19, 23)
    {
      $txt .= ShowLine(Op("intro",ShowUnary($i)));
    }

  foreach my $i (0, 1, 4, 9, 16, 25)
    {
      $txt .= ShowLine(Op("intro",ShowUnary($i)));
    }

  foreach my $i (0, 1, 8, 27)
    {
      $txt .= ShowLine(Op("intro",ShowUnary($i)));
    }


  $txt .= "# MATH now show equality\n";

  $txt .= ShowLine(Op("intro","="));
  my @examples = prand(10,5);
  for (my $i=0; $i<=$#examples; $i++)
    {
      my $r = $examples[$i];
      $txt .= ShowLine(Op2("=",ShowUnary($r),ShowUnary($r)));
    }

  $txt .= "# MATH now show other relational operators\n";

  $txt .= ShowLine(Op("intro",">"));
  for (my $i=0; $i<=10; $i++)
    {
      my $r = irand(6);
      my $r2 = irand($r);
      $txt .= ShowLine(Op2(">",ShowUnary($r+1),ShowUnary($r2)));
    }
  $txt .= ShowLine(Op("intro","<"));
  for (my $i=0; $i<=10; $i++)
    {
      my $r = irand(6);
      my $r2 = irand($r);
      $txt .= ShowLine(Op2("<",ShowUnary($r2),ShowUnary($r+1)));
    }
  for (my $i=0; $i<=10; $i++)
    {
      my $r = irand(6);
      my $r2 = irand(6);
      my $cmp = "=";
      if ($r>$r2)
	{
	  $cmp = ">";
	}
      elsif ($r<$r2)
	{
	  $cmp = "<";
	}
      $txt .= ShowLine(Op2($cmp,ShowUnary($r),ShowUnary($r2)));
    }

  return $txt;
};


ShowLesson(ShowUnaryLesson());

