#!/usr/bin/perl -w

use strict;

if ($#ARGV<1) 
  {
    die "not enough arguments";
  }

my $BASEDIR = $ARGV[0];
my $BASEFILE = $ARGV[1];

open(COM,"<COMMENTS.TXT");
my $txt = "";
while(<COM>)
  {
    $txt .= $_;
  }

open(REF,"<unwrapped.txt");
my @ref = ();
while(<REF>)
  {
    chomp;
    push(@ref,$_);
  }

my $txt0 = $txt;
my $txt1 = $txt;
$txt0 =~ s/[\n\r]*MORE(.|[\n\r])*//;
$txt1 =~ s/(.|[\n\r])*MORE.*[\n\r]*//;
$txt0 =~ s/\n\n+/\<P\>/g;
$txt1 =~ s/\n\n+/\<P\>/g;

open(MSG,"<color.txt");
my $msg = "";
while(<MSG>)
  {
      $msg .= $_;
  }

open(AMSG,">message-verbose.html");
my $imsg = "";

print AMSG "<HTML><HEAD><TITLE>CosmicOS message</TITLE></HEAD>\n";
print AMSG "<BODY BGCOLOR='#ffffff'>\n";
my $name = 0;
my $ref_index = 0;
my $intro = 0;
for my $m (split(/\n/,$msg))
  {
    my $s = $m;
    $s =~ s/\&/&amp;/g;
    $s =~ s/\</&lt;/g;
    $s =~ s/\>/&gt;/g;
    $s =~ s/\&lt\;font style=\'background\-color\: \#(......)\'\&gt\;/\<font style=\'background\-color\: \#$1\'\>/g;
    $s =~ s/\&lt\;\/font\&gt\;/\<\/font\>/g;
    my $prefix = "";
    my $postfix = "";
    my $novel = 1;
    if ($m =~ /\#  ?[A-Z][A-Z]/)
      {
	if ($s =~ /\# *([A-Z]+) *(.*)/)
	  {
	    my $sect = $1;
	    my $comment = $2;
	    $prefix = "<A NAME='$name'><FONT COLOR=red>";

    $imsg .= "<TR><TD ALIGN=RIGHT><A HREF='message-section-" . sprintf("%06d",$name) . ".html'>$name</A> </TD><TD>&nbsp;&nbsp;</TD><TD> $comment </TD><TD> ($sect) </TD></TR>\n";
#	    $imsg .= "<TR><TD ALIGN=RIGHT><A HREF='message-verbose.html#$name'>$name</A> </TD><TD>&nbsp;&nbsp;</TD><TD> $comment </TD><TD> ($sect) </TD></TR>\n";
	    $name = $name+1;
	    $postfix = "</FONT>";
	    if (!$intro) {
		print AMSG "<HR>\n";
		$intro = 1;
	    }
	  }
	$novel = 0;
      }
    if ($s =~ /^([ \t]+)/)
      {
	my $space = $1;
	$space =~ s/\t/    /g;
	$space =~ s/ /\&nbsp\;/g;
	$s =~ s/^[ \t]+/$space/;
	$novel = 0;
      }
    my $s2 = $s;
    if ($s =~ /^\#/) { 
	$novel = 0; 
	if ($s =~ /^(\#[ \t]+)/) {
	    my $f = $1;
	    my $qf = quotemeta($f);
	    $f =~ s/ /\&nbsp\;/g;
	    $f =~ s/\t/\&nbsp\;\&nbsp\;\&nbsp\;\&nbsp\;\&nbsp\;\&nbsp\;\&nbsp\;\&nbsp\;/g;
	    $s2 =~ s/^$qf/$f/;
	}
    }
    if ($novel) {
	$intro = 0;
	print AMSG "<TT>[<A HREF='http://people.csail.mit.edu/people/paulfitz/cosmic/cosmic.0.7/make_wave3.cgi?s=$ref[$ref_index]'>hear</A>] </TT>";
	if (!defined($ref[$ref_index])) {
	    print "PROBLEM at index $ref_index ($prefix$s2$postfix)\n";
	    exit 1;
	}
      $ref_index++;
    } else {
      print AMSG "<TT>\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;\&nbsp;</TT>";
    }
    print AMSG "<TT>$prefix$s2$postfix</TT><BR>\n";
    my $m = "$prefix$s$postfix";
    $m =~ s/\&[a-z]+\;//g;
    if (($m =~ /[\;]/) && !($m=~/\# /)) {
	print AMSG "<BR>\n";
    }
  }

$imsg = "<TABLE BORDER=0>\n$imsg</TABLE>\n";

print AMSG "<HR>\n";
print AMSG "</BODY>\n";
print AMSG "</HTML>\n";
close(AMSG);

open(TEMPLATE,"<template.html");
my $plate = "";
while(<TEMPLATE>)
  {
    $plate .= $_;
  }


my $entropy = `cp wrapped.txt entropy.txt; gzip -q -f entropy.txt; wc -c < entropy.txt.gz; rm -f entropy.txt.gz`;
my $imgsize = `./imgsize.pl view.png`;
$entropy = $entropy/1024;
$entropy = int(0.5+$entropy*10)/10;

$plate =~ s/XXX/$txt0/g;
$plate =~ s/MMM/$txt1/g;
$plate =~ s/DDD/$BASEDIR/g;
$plate =~ s/FFF/$BASEFILE/g;
$plate =~ s/III/$imsg/g;
$plate =~ s/EEE/$entropy/g;
$plate =~ s/SSS/$imgsize/g;

print $plate;
